Subject: bug#40687: closed (Re: bug#40687: Missing right border on composed text used in 'display property)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 24 Apr 2020 12:28:02 +0000

Your bug report

#40687: Missing right border on composed text used in 'display property

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
40687: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=40687
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#40687: Missing right border on composed text used in 'display property
From: Eli Zaretskii <[email-masked]>
To: Robert Pluim <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Fri, 24 Apr 2020 15:26:58 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Robert Pluim <[email-masked]>
> Cc: Clément Pit-Claudel <[email-masked]>,
>   [email-masked]
> Date: Fri, 24 Apr 2020 14:10:57 +0200
> 
> >>>>> On Thu, 23 Apr 2020 18:48:09 +0300, Eli Zaretskii <[email-masked]> said:
> 
>     Eli> Thanks, should be fixed now.
> 
>     Eli> FTR, a recipe to test more fully display of composed text with a :box
>     Eli> face is below.  I found quite a few problems with this, especially
>     Eli> when the text in the boxed face ends with a composed character.  They
>     Eli> should be fixed now on the master branch.  I tested this fully only on
>     Eli> MS-Windows; could someone please use the recipe below to verify the
>     Eli> display looks correctly also on X and on NS?  Note that what appears
>     Eli> below to be LATIN SMALL LETTER A WITH ACUTE is not a single character,
>     Eli> but 2 characters that are composed into a single glyph.
> 
> It all looks correct on NS as well (once I switched to a font that had both
> an 'a' and a COMBINING ACUTE ACCENT glyph, Menlo in this case)

Great, so I'm closing this bug.  Thanks to all who supported the
testing of the fix.

P.S. FTR: the fix is on the master branch, so it will be in Emacs
28.1.

Subject: Missing right border on composed text used in 'display property
From: Clément Pit-Claudel <[email-masked]>
To: bug-gnu-emacs <[email-masked]>
Date: Fri, 17 Apr 2020 15:44:36 -0400
List-Id: <debbugs-submit.debbugs.gnu.org>

Hi all,

With the following sample code, I observe the results shown in the attached image.  The first two "ab" have a border, but the last one only has three-quarters of its border: the right side is missing.

(defface my-button
  '((t :box(:line-width -4 :style released-button)
       :background"lightgrey":foreground"black"))
  "Button face")

(with-current-buffer (get-buffer-create "button")
  (insert "\n")
  (insert (propertize "ab" 'face 'my-button))
  (insert " ")
  (insert (propertize (compose-chars ?a '(Br . Bl) ?b) 'face 'my-button))
  (insert " ")
  (insert (propertize "ab" 'display (compose-chars ?a '(Br . Bl) ?b) 'face 'my-button))
  (insert " ")
  (pop-to-buffer-same-window (current-buffer)))

Clément.

In GNU Emacs 28.0.50 (build 5, x86_64-pc-linux-gnu, GTK+ Version 3.22.30, cairo version 1.15.10)
 of 2020-03-15 built on clem-w50-mint
Repository revision: 9dccaf8a5cdb10dae597345ec3741475477a7d97
Repository branch: master
Windowing system distributor 'The X.Org Foundation', version 11.0.11906000
System Description: Linux Mint 19.3

Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.

Configured features:
XPM JPEG TIFF GIF PNG RSVG CAIRO SOUND GPM DBUS GSETTINGS GLIB NOTIFY
INOTIFY ACL LIBSELINUX GNUTLS LIBXML2 FREETYPE HARFBUZZ M17N_FLT LIBOTF
ZLIB TOOLKIT_SCROLL_BARS GTK3 X11 XDBE XIM MODULES THREADS LIBSYSTEMD
JSON PDUMPER LCMS2 GMP

Important settings:
  value of $LC_MONETARY: en_DK.UTF-8
  value of $LC_NUMERIC: en_DK.UTF-8
  value of $LC_TIME: en_DK.UTF-8
  value of $LANG: en_US.UTF-8
  value of $XMODIFIERS: @im=ibus
  locale-coding-system: utf-8-unix

Major mode: Fundamental

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny dired dired-loaddefs
format-spec rfc822 mml easymenu mml-sec password-cache epa derived epg
epg-config gnus-util rmail rmail-loaddefs text-property-search time-date
subr-x seq byte-opt gv bytecomp byte-compile cconv mm-decode mm-bodies
mm-encode mail-parse rfc2231 mailabbrev gmm-utils mailheader cl-loaddefs
cl-lib sendmail rfc2047 rfc2045 ietf-drums mm-util mail-prsvr mail-utils
tooltip eldoc electric uniquify ediff-hook vc-hooks lisp-float-type
mwheel term/x-win x-win term/common-win x-dnd tool-bar dnd fontset image
regexp-opt fringe tabulated-list replace newcomment text-mode elisp-mode
lisp-mode prog-mode register page tab-bar menu-bar rfn-eshadow isearch
timer select scroll-bar mouse jit-lock font-lock syntax facemenu
font-core term/tty-colors frame minibuffer cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote threads dbusbind
inotify lcms2 dynamic-setting system-font-setting font-render-setting
cairo move-toolbar gtk x-toolkit x multi-tty make-network-process emacs)

Memory information:
((conses 16 45833 8246)
 (symbols 48 6336 1)
 (strings 32 15876 1701)
 (string-bytes 1 514312)
 (vectors 16 10216)
 (vector-slots 8 138591 9384)
 (floats 8 19 45)
 (intervals 56 188 0)
 (buffers 1000 12))